﻿@model IEnumerable<eCommerce.BackOffice.ViewModels.CategoryViewModel>
@{
    ViewBag.Title = "Ordenar Catálogo";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}
@using eCommerce.Services.Model.Enums
<style>
    #loadingDiv {
        position: fixed;
        top: 0px;
        right: 0px;
        width: 100%;
        height: 100%;
        background-color: #666;
        background-image: url('/Content/assets/images/AjaxLoader.gif');
        background-repeat: no-repeat;
        background-position: center;
        z-index: 10000000;
        opacity: 0.4;
        filter: alpha(opacity=40); /* For IE8 and earlier */
        display: none;
    }

    .product-wrapper {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        background: white;
    }

        .product-wrapper .title {
            width: 100%;
            text-align: start;
            font-size: 12px;
            text-overflow: ellipsis;
            max-width: 140px;
            color: black;
            text-transform: capitalize;
            text-align: center;
        }

        .product-wrapper img {
            margin-bottom: 10px;
            max-width: 148px;
        }

    .product-grid {
        list-style-type: none;
        display: flex;
        flex-wrap: wrap;
        justify-content: flex-start;
        margin: 0 auto;
    }

        .product-grid .product-item {
            width: 150px;
            margin: 1rem;
            border: 1px solid #e6e6e6;
        }

            .product-grid .product-item:hover {
                cursor: grab;
                -webkit-filter: grayscale(100%); /* Safari 6.0 - 9.0 */
                filter: grayscale(100%);
            }

            .product-grid .product-item.selected {
                cursor: grab;
                -webkit-filter: grayscale(100%); /* Safari 6.0 - 9.0 */
                filter: grayscale(100%);
            }

    .flex {
        display: flex;
        justify-content: space-between;
        align-items: center;
        padding: 20px 20px;
    }

    .flex-center {
        display: flex;
        justify-content: flex-start;
        align-items: center;
    }

    @@media(max-width:768px) {
        .flex-center {
            flex-direction: column;
        }
    }
</style>
<link rel="stylesheet" href="http://code.jquery.com/ui/1.9.2/themes/base/jquery-ui.css" />
<div class="page-header">
    <h1 class="page-title">Ordenar Catálogo</h1>
</div>
<div class="flex">
    <div class="form-group col-md-6 col-xs-12 flex-center">
        <div class="col-md-6 col-xs-12">
            <label class="control-label">Categoría</label>
            <select class="form-control js-filter-input" id="CategoryId" data-plugin="select2">
                <option value="">Seleccionar una Categoría</option>
                @foreach (var category in Model)
                {
                    <option value="@category.Id">@category.Name</option>
                }
            </select>
        </div>
    </div>
    <div>
        <button type="submit" class="js-submit btn btn-success">Guardar</button>
    </div>
</div>
<div class="row">
    <div class="panel">
        <div id="data" class="dd js-nest" data-plugin="nestable">
        </div>
    </div>
</div>
<div id="loadingDiv"></div>

@section Scripts {

    <script type="text/javascript" src="https://code.jquery.com/jquery.min.js"></script>
    <script type="text/javascript" src="https://code.jquery.com/ui/1.9.2/jquery-ui.js"></script>
    <script type="text/javascript" src="https://www.pureexample.com/js/lib/jquery.ui.touch-punch.min.js"></script>

    <script type="text/javascript">

        $('.js-submit').click(function(){

            debugger;
            var productsJson = getProductsOrderJson();
            var CategoryId = $('#CategoryId').val();

            $.ajax({
                url: "/Products/DisplayOrder/",
                type: "Post",
                cache: false,
                data: { productsJson: productsJson, CategoryId: CategoryId },
                success: function (data) {
                    if (data.success)
                        toastr.success('Hecho, se guardaron los cambios!');
                    else
                        toastr.error('Se produjo un error al intentar guardar los cambios');
                }
            });
        });

        $('.js-filter-input').change(function () {
            GetProducts();
        });

        function getProductsOrderJson() {
            var productArray = new Array();
            var productObject;
            $.each($('.js-product'), function (index, product) {
                var productObject = new Object();
                productObject = { 'id': $(product).data('id'), 'order': index };
                productArray.push(productObject);
            });
            return JSON.stringify(productArray);
        }


        function GetProducts()
        {
            debugger;

            var categoryId = $('#CategoryId').val();
            var publishedTypeId = $('#PublishedTypeId').val();
            if (categoryId != undefined && categoryId != null && categoryId != '') {
                $("#loadingDiv").show();
                $.ajax({
                    url: "/Products/ProductsOrderList/",
                    type: "GET",
                    data: { CategoryId: categoryId, PublishedTypeId: publishedTypeId },
                    success: function (data) {
                        $("#loadingDiv").hide();
                        if (data != "") {
                            $('#data').html(data);
                        }
                        cantItems = $('.item').length;
                        itemsPositions = new Array();
                        addSortable();
                    },
                    error: function (request, status, error) {
                        $("#loadingDiv").hide();
                        //$(".error-message h2").text("Se produjo un error al consultar los datos");
                    }
                });
            }
        }

        function addSortable() {
            $("#products").sortable({
                start: function (event, ui) {
                    ui.item.toggleClass("selected");
                },
                stop: function (event, ui) {
                    ui.item.toggleClass("selected");
                }
            });
            $("#products").disableSelection();

        }

    </script>

}

